unit uprojekte;

{$mode ObjFPC}{$H+}

interface

uses
  Classes, SysUtils;

type
  TProjekt = record                                                          // Satzaufbau Projekte
    Projektnummer: integer;
    Projektname: string;
    Beschreibung: array of string;
    Anzahl: integer;
    Status: string;                                                               // erfasst/gestartet/beendet
    Sollstarttermin: TDateTime;
    Sollendtermin: TDateTime;
    Iststarttermin: TDateTime;
    Istendtermin: TDateTime;
    Terminart: string;                                                            // Festtermin/Variabletermin
    Verantwortlich: integer;
    Satzart: Boolean;                                                             // aktiv/passiv
  end;



var
  Projektpfad: string;                                                          // Pfad der Projektfiles
  Projektfile: string;                                                          // Filename des Projektfile
  Projektname: string;                                                          // Projektname
  Projektnummer: integer;                                                       // Projektnummer
  Projektstatus: string;                                                        // Projektstatus (E=erfasst G=gestartet B=beendet)
  Projektstart: TDateTime;                                                      // Projekt-Start Termin (Datum und Zeit)
  Projektende: TDateTime;                                                       // Projekt-Ende Termin (Datum und Zeit)
  Projekt: Tprojekt;                                                            // Daten Projekt
  Projektzaehl: integer;                                                        // Zähler Tabelle Vorgänge
  Updprojekt: Boolean;                                                          // Projekttabelle wurde geändert


implementation

end.

