unit Unit3;

{$mode ObjFPC}{$H+}

interface

uses
  Classes, SysUtils, Forms, Controls, StdCtrls, Grids,
  Dialogs, ExtCtrls, Eingabe, Graphics;

type

  { TFrame2 }

  TFrame2 = class(TFrame)
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    Button4: TButton;
    ComboBox1: TComboBox;
    ComboBox2: TComboBox;
    Edit1: TEdit;
    Edit10: TEdit;
    Edit11: TEdit;
    Edit12: TEdit;
    Edit13: TEdit;
    Edit14: TEdit;
    Edit2: TEdit;
    Edit3: TEdit;
    Edit4: TEdit;
    Edit5: TEdit;
    Edit6: TEdit;
    Edit7: TEdit;
    Edit8: TEdit;
    Edit9: TEdit;
    Label1: TLabel;
    Label10: TLabel;
    Label11: TLabel;
    Label12: TLabel;
    Label13: TLabel;
    Label14: TLabel;
    Label15: TLabel;
    Label16: TLabel;
    Label17: TLabel;
    Label18: TLabel;
    Label19: TLabel;
    Label2: TLabel;
    Label20: TLabel;
    Label21: TLabel;
    Label22: TLabel;
    Label23: TLabel;
    Label24: TLabel;
    Label25: TLabel;
    Label26: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    Label9: TLabel;
    StringGrid1: TStringGrid;
    Timer1: TTimer;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure ComboBox1Change(Sender: TObject);
    procedure ComboBox2Change(Sender: TObject);
    procedure Edit10KeyPress(Sender: TObject; var Key: Char);
    procedure Edit10KeyUp(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure Edit11KeyPress(Sender: TObject; var Key: Char);
    procedure Edit11KeyUp(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure Edit12KeyPress(Sender: TObject; var Key: Char);
    procedure Edit12KeyUp(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure Edit13KeyPress(Sender: TObject; var Key: Char);
    procedure Edit13KeyUp(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure Edit14KeyPress(Sender: TObject; var Key: Char);
    procedure Edit14KeyUp(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure Edit1KeyPress(Sender: TObject; var Key: Char);
    procedure Edit1KeyUp(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure Edit2KeyPress(Sender: TObject; var Key: Char);
    procedure Edit2KeyUp(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure Edit3KeyPress(Sender: TObject; var Key: Char);
    procedure Edit3KeyUp(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure Edit4KeyPress(Sender: TObject; var Key: Char);
    procedure Edit4KeyUp(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure Edit5KeyPress(Sender: TObject; var Key: Char);
    procedure Edit5KeyUp(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure Edit6KeyPress(Sender: TObject; var Key: Char);
    procedure Edit6KeyUp(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure Edit7KeyPress(Sender: TObject; var Key: Char);
    procedure Edit7KeyUp(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure Edit8KeyPress(Sender: TObject; var Key: Char);
    procedure Edit8KeyUp(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure Edit9KeyPress(Sender: TObject; var Key: Char);
    procedure Edit9KeyUp(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure StringGrid1SelectCell(Sender: TObject; aCol, aRow: Integer; var CanSelect: Boolean);
    procedure Timer1Timer(Sender: TObject);
  private
    AOwner: TComponent;
    FOnCloseMe: TNotifyEvent;
    procedure SetVariables(aialpha: String; ainummer, aiart, ainumkom, aikomma, aizeich, aistell, aifunc, ailanmax, ailanmin, aiautocr: Integer);
    procedure SetControlStatus(ctrl: TObject; aenabled: Boolean; atext: String = '');
  public
    constructor Create(AOwner1: TComponent); override;                          // Frame initialisieren (Variable und Komponenteneigenschaften)
    destructor Destroy; override;                                               // Frame schliessen
    procedure FBLoe;                                                            // Löschen Eingabefelder Bildschirm
    procedure Ladenpersonen;                                                    // Laden Daten Personen aus Tabelle in Stringgrid
    property OnCloseMe: TNotifyEvent read FOnCloseMe write FOnCloseMe;
  end;

type
  Tfperson = record                                                           // Satzaufbau Personen
    Nummer: Integer;
    Art: String;                                                                  // Person/Firma
    Firmenname: String;
    Vorname: String;
    Nachname: String;
    Strasse: String;
    Hausnummer: String;
    Plz: String;
    Ort: String;
    Land: String;
    Telefon: String;
    Handy: String;
    Email: String;
    Partneranrede: String;
    Partnervorname: String;
    Partnernachname: String;
    Partnertelefon: String;
    Satzart: Boolean;                                                             // aktiv/passiv
  end;

var
  ftasts: Boolean;                                                              // Darf ein Button gedrückt werden
  fart: Integer;                                                                // Verarbeitungsart 1=Insert 2=Update 3=Delete
  flauf: Integer;                                                               // Welche Eingabe ist zulässig 0=keine Eingabe
  fgrid: Integer;                                                               // Nummer der angeklickten Zeile im Stringgrid
  fperson: Tfperson;

implementation

{$R *.lfm}

uses
  uprjhelper, upersonen;

  { TFrame2 }

destructor TFrame2.Destroy;
begin
  AOwner.Free;
  inherited Destroy;
end;

procedure TFrame2.Button4Click(Sender: TObject);
begin
  Label1.Caption := UTF8Encode(#169) + 'LINSOFT               Projektverwaltung                   Datum: ' + FormatDateTime('DD.MM.YYYY', now);
  if ftasts then
  begin
    Label2.Caption := '';
    ftasts := False;
    fart := 0;
    flauf := 0;
    if assigned(FOnCloseMe) then
      FOnCloseMe(self);
  end;
end;

procedure TFrame2.ComboBox1Change(Sender: TObject);
var
  h1: String;
begin
  if flauf = 1 then
  begin
    Label2.Caption := '';
    h1 := ComboBox1.Text;
    ialpha := Blankweg(3, h1);
    if ialpha <> '' then
    begin
      fperson.Art := ialpha;
      SetControlStatus(ComboBox1, False, '@');
      if ialpha = 'Person' then
      begin
        flauf := 3;
        SetControlStatus(Edit1, True);
        SetVariables('', 0, 2, 0, 0, 3, 0, 5, 25, 1, 1);
        if fart = 2 then
        begin
          Edit1.Text := fperson.Vorname;
          ialpha := fperson.Vorname;
          iart := 1;
        end;
      end
      else
      begin
        flauf := 2;
        SetControlStatus(Edit9, True);
        SetVariables('', 0, 2, 0, 0, 3, 0, 5, 30, 1, 1);
        if fart = 2 then
        begin
          Edit9.Text := fperson.Firmenname;
          ialpha := fperson.Firmenname;
          iart := 1;
        end;
      end;
    end
    else
    begin
      Label2.Caption := 'Personenart muss ausgewählt werden';
    end;
  end;
end;

procedure TFrame2.ComboBox2Change(Sender: TObject);
var
  h1: String;
  h2: Integer;
  JaNein: TModalResult;
begin
  if flauf = 13 then
  begin
    Label2.Caption := '';
    h1 := ComboBox2.Text;
    ialpha := Blankweg(3, h1);
    if ialpha <> '' then
    begin
      fperson.Partneranrede := ialpha;
      SetControlStatus(ComboBox2, True, '@');
      if ialpha = 'ohne' then
      begin
        if fart = 1 then
        begin
          JaNein := messagedlg('Person/Firma anlegen?', mtConfirmation, [mbYes, mbNo], 0);
          if (JaNein = mrYes) then
          begin
            h2 := fperson.Nummer;
            Persontab[h2].Nummer := h2;
            Persontab[h2].Art := fperson.Art;
            Persontab[h2].Land := fperson.Land;
            Persontab[h2].Email := fperson.Email;
            Persontab[h2].Handy := fperson.Handy;
            Persontab[h2].Telefon := fperson.Telefon;
            Persontab[h2].Ort := fperson.Ort;
            Persontab[h2].Plz := fperson.Plz;
            Persontab[h2].Hausnummer := fperson.Hausnummer;
            Persontab[h2].Strasse := fperson.Strasse;
            Persontab[h2].Nachname := fperson.Nachname;
            Persontab[h2].Firmenname := fperson.Firmenname;
            Persontab[h2].Vorname := fperson.Vorname;
            Persontab[h2].Partnertelefon := fperson.Partnertelefon;
            Persontab[h2].Partnernachname := fperson.Partnernachname;
            Persontab[h2].Partnervorname := fperson.Partnervorname;
            Persontab[h2].Partneranrede := fperson.Partneranrede;
            Persontab[h2].Satzart := True;
            Personzaehl := Personzaehl + 1;
            Updperson := True;
            Ladenpersonen;
          end;
        end
        else
        begin
          JaNein := messagedlg('Person/Firma ändern?', mtConfirmation, [mbYes, mbNo], 0);
          if (JaNein = mrYes) then
          begin
            h2 := fperson.Nummer;
            Persontab[h2].Nummer := h2;
            Persontab[h2].Art := fperson.Art;
            Persontab[h2].Land := fperson.Land;
            Persontab[h2].Email := fperson.Email;
            Persontab[h2].Handy := fperson.Handy;
            Persontab[h2].Telefon := fperson.Telefon;
            Persontab[h2].Ort := fperson.Ort;
            Persontab[h2].Plz := fperson.Plz;
            Persontab[h2].Hausnummer := fperson.Hausnummer;
            Persontab[h2].Strasse := fperson.Strasse;
            Persontab[h2].Nachname := fperson.Nachname;
            Persontab[h2].Firmenname := fperson.Firmenname;
            Persontab[h2].Vorname := fperson.Vorname;
            Persontab[h2].Partnertelefon := fperson.Partnertelefon;
            Persontab[h2].Partnernachname := fperson.Partnernachname;
            Persontab[h2].Partnervorname := fperson.Partnervorname;
            Persontab[h2].Partneranrede := fperson.Partneranrede;
            Persontab[h2].Satzart := True;
            Updperson := True;
            Ladenpersonen;
          end;
        end;
        flauf := 0;
        fart := 0;
        ftasts := True;
        FBLoe;
      end
      else
      begin
        flauf := 14;
        SetControlStatus(Edit12, True);
        SetVariables('', 0, 2, 0, 0, 3, 0, 5, 20, 1, 1);
        if fart = 2 then
        begin
          Edit12.Text := fperson.Partnertelefon;
          ialpha := fperson.Partnertelefon;
          iart := 1;
        end;
      end;
    end
    else
    begin
      Label2.Caption := 'Partneranrede muss ausgewählt werden';
    end;
  end;
end;

procedure TFrame2.Edit10KeyPress(Sender: TObject; var Key: Char);
begin
  if flauf = 11 then
  begin
    itaste := Key;
    FeldEingabe(Edit10);
    Key := itaste;
  end;
end;

procedure TFrame2.Edit10KeyUp(Sender: TObject; var Key: Word; Shift: TShiftState);
var
  h1: String;
begin
  Shift := Shift;
  if flauf = 11 then
  begin
    if ((istell = ilanmax) and (Ord(itaste) > 0) and (iautocr = 1)) then
    begin
      Key := Ord(chr(13));
    end;
    if Ord(Key) = 13 then
    begin
      Label2.Caption := '';
      istell := 0;
      SetControlStatus(Edit10, False, '@');
      h1 := Edit10.Text;
      ialpha := Blankweg(3, h1);
      fperson.Email := ialpha;
      flauf := 12;
      SetControlStatus(Edit11, True);
      SetVariables('', 0, 2, 0, 0, 3, 0, 5, 30, 1, 1);
      if fart = 2 then
      begin
        Edit11.Text := fperson.Land;
        ialpha := fperson.Land;
        iart := 1;
      end;
    end;
  end;
end;

procedure TFrame2.Edit11KeyPress(Sender: TObject; var Key: Char);
begin
  if flauf = 12 then
  begin
    itaste := Key;
    FeldEingabe(Edit11);
    Key := itaste;
  end;
end;

procedure TFrame2.Edit11KeyUp(Sender: TObject; var Key: Word; Shift: TShiftState);
var
  h1: String;
  h2: Integer;
  JaNein: TModalResult;
begin
  Shift := Shift;
  if flauf = 12 then
  begin
    if ((istell = ilanmax) and (Ord(itaste) > 0) and (iautocr = 1)) then
    begin
      Key := Ord(chr(13));
    end;
    if Ord(Key) = 13 then
    begin
      Label2.Caption := '';
      istell := 0;
      SetControlStatus(Edit11, False, '@');
      h1 := Edit11.Text;
      ialpha := Blankweg(3, h1);
      if ialpha <> '' then
      begin
        fperson.Land := ialpha;
        if fperson.Art = 'Person' then
        begin
          if fart = 1 then
          begin
            JaNein := messagedlg('Person/Firma anlegen?', mtConfirmation, [mbYes, mbNo], 0);
            if (JaNein = mrYes) then
            begin
              h2 := fperson.Nummer;
              Persontab[h2].Nummer := h2;
              Persontab[h2].Art := fperson.Art;
              Persontab[h2].Land := fperson.Land;
              Persontab[h2].Email := fperson.Email;
              Persontab[h2].Handy := fperson.Handy;
              Persontab[h2].Telefon := fperson.Telefon;
              Persontab[h2].Ort := fperson.Ort;
              Persontab[h2].Plz := fperson.Plz;
              Persontab[h2].Hausnummer := fperson.Hausnummer;
              Persontab[h2].Strasse := fperson.Strasse;
              Persontab[h2].Nachname := fperson.Nachname;
              Persontab[h2].Firmenname := fperson.Firmenname;
              Persontab[h2].Vorname := fperson.Vorname;
              Persontab[h2].Partnertelefon := fperson.Partnertelefon;
              Persontab[h2].Partnernachname := fperson.Partnernachname;
              Persontab[h2].Partnervorname := fperson.Partnervorname;
              Persontab[h2].Partneranrede := fperson.Partneranrede;
              Persontab[h2].Satzart := True;
              Personzaehl := Personzaehl + 1;
              Updperson := True;
              Ladenpersonen;
            end;
          end
          else
          begin
            JaNein := messagedlg('Person/Firma ändern?', mtConfirmation, [mbYes, mbNo], 0);
            if (JaNein = mrYes) then
            begin
              h2 := fperson.Nummer;
              Persontab[h2].Nummer := h2;
              Persontab[h2].Art := fperson.Art;
              Persontab[h2].Land := fperson.Land;
              Persontab[h2].Email := fperson.Email;
              Persontab[h2].Handy := fperson.Handy;
              Persontab[h2].Telefon := fperson.Telefon;
              Persontab[h2].Ort := fperson.Ort;
              Persontab[h2].Plz := fperson.Plz;
              Persontab[h2].Hausnummer := fperson.Hausnummer;
              Persontab[h2].Strasse := fperson.Strasse;
              Persontab[h2].Nachname := fperson.Nachname;
              Persontab[h2].Firmenname := fperson.Firmenname;
              Persontab[h2].Vorname := fperson.Vorname;
              Persontab[h2].Partnertelefon := fperson.Partnertelefon;
              Persontab[h2].Partnernachname := fperson.Partnernachname;
              Persontab[h2].Partnervorname := fperson.Partnervorname;
              Persontab[h2].Partneranrede := fperson.Partneranrede;
              Persontab[h2].Satzart := True;
              Updperson := True;
              Ladenpersonen;
            end;
          end;
          flauf := 0;
          fart := 0;
          ftasts := True;
          FBLoe;
        end
        else
        begin
          flauf := 13;
          SetControlStatus(ComboBox2, True, 'ohne');
        end;
      end
      else
      begin
        Label2.Caption := 'Land muss eingegeben werden';
        SetControlStatus(Edit11, True);
        SetVariables('', 0, 2, 0, 0, 3, 0, 5, 30, 1, 1);
        if fart = 2 then
        begin
          Edit11.Text := fperson.Land;
          ialpha := fperson.Land;
          iart := 1;
        end;
      end;
    end;
  end;
end;

procedure TFrame2.Edit12KeyPress(Sender: TObject; var Key: Char);
begin
  if flauf = 14 then
  begin
    itaste := Key;
    FeldEingabe(Edit12);
    Key := itaste;
  end;
end;

procedure TFrame2.Edit12KeyUp(Sender: TObject; var Key: Word; Shift: TShiftState);
var
  h1: String;
begin
  Shift := Shift;
  if flauf = 14 then
  begin
    if ((istell = ilanmax) and (Ord(itaste) > 0) and (iautocr = 1)) then
    begin
      Key := Ord(chr(13));
    end;
    if Ord(Key) = 13 then
    begin
      Label2.Caption := '';
      istell := 0;
      SetControlStatus(Edit12, False, '@');
      h1 := ialpha;
      ialpha := Blankweg(3, h1);
      if ialpha <> '' then
      begin
        fperson.Partnertelefon := ialpha;
        flauf := 15;
        SetControlStatus(Edit13, True);
        SetVariables('', 0, 2, 0, 0, 3, 0, 5, 25, 1, 1);
        if fart = 2 then
        begin
          Edit13.Text := fperson.Partnervorname;
          ialpha := fperson.Partnervorname;
          iart := 1;
        end;
      end
      else
      begin
        Label2.Caption := 'Partnertelefon muss eingegeben werden';
        SetControlStatus(Edit12, True);
        SetVariables('', 0, 2, 0, 0, 3, 0, 5, 20, 1, 1);
        if fart = 2 then
        begin
          Edit12.Text := fperson.Partnertelefon;
          ialpha := fperson.Partnertelefon;
          iart := 1;
        end;
      end;
    end;
  end;
end;

procedure TFrame2.Edit13KeyPress(Sender: TObject; var Key: Char);
begin
  if flauf = 15 then
  begin
    itaste := Key;
    FeldEingabe(Edit13);
    Key := itaste;
  end;
end;

procedure TFrame2.Edit13KeyUp(Sender: TObject; var Key: Word; Shift: TShiftState);
var
  h1: String;
begin
  Shift := Shift;
  if flauf = 15 then
  begin
    if ((istell = ilanmax) and (Ord(itaste) > 0) and (iautocr = 1)) then
    begin
      Key := Ord(chr(13));
    end;
    if Ord(Key) = 13 then
    begin
      Label2.Caption := '';
      istell := 0;
      SetControlStatus(Edit13, False, '@');
      h1 := Edit13.Text;
      ialpha := Blankweg(3, h1);
      if ialpha <> '' then
      begin
        fperson.Partnervorname := ialpha;
        flauf := 16;
        SetControlStatus(Edit14, True);
        SetVariables('', 0, 2, 0, 0, 3, 0, 5, 25, 1, 1);
        if fart = 2 then
        begin
          Edit14.Text := fperson.Partnernachname;
          ialpha := fperson.Partnernachname;
          iart := 1;
        end;
      end
      else
      begin
        Label2.Caption := 'Partnervorname muss eingegeben werden';
        SetControlStatus(Edit13, True);
        SetVariables('', 0, 2, 0, 0, 3, 0, 5, 20, 1, 1);
        if fart = 2 then
        begin
          Edit13.Text := fperson.Partnertelefon;
          ialpha := fperson.Partnertelefon;
          iart := 1;
        end;
      end;
    end;
  end;
end;

procedure TFrame2.Edit14KeyPress(Sender: TObject; var Key: Char);
begin
  if flauf = 16 then
  begin
    itaste := Key;
    FeldEingabe(Edit14);
    Key := itaste;
  end;
end;

procedure TFrame2.Edit14KeyUp(Sender: TObject; var Key: Word; Shift: TShiftState);
var
  h1: String;
  h2: Integer;
  JaNein: TModalResult;
begin
  Shift := Shift;
  if flauf = 16 then
  begin
    if ((istell = ilanmax) and (Ord(itaste) > 0) and (iautocr = 1)) then
    begin
      Key := Ord(chr(13));
    end;
    if Ord(Key) = 13 then
    begin
      Label2.Caption := '';
      istell := 0;
      SetControlStatus(Edit14, False, '@');
      h1 := Edit14.Text;
      ialpha := Blankweg(3, h1);
      if ialpha <> '' then
      begin
        fperson.Partnernachname := ialpha;
        if fart = 1 then
        begin
          JaNein := messagedlg('Person/Firma anlegen?', mtConfirmation, [mbYes, mbNo], 0);
          if (JaNein = mrYes) then
          begin
            h2 := fperson.Nummer;
            Persontab[h2].Nummer := h2;
            Persontab[h2].Art := fperson.Art;
            Persontab[h2].Land := fperson.Land;
            Persontab[h2].Email := fperson.Email;
            Persontab[h2].Handy := fperson.Handy;
            Persontab[h2].Telefon := fperson.Telefon;
            Persontab[h2].Ort := fperson.Ort;
            Persontab[h2].Plz := fperson.Plz;
            Persontab[h2].Hausnummer := fperson.Hausnummer;
            Persontab[h2].Strasse := fperson.Strasse;
            Persontab[h2].Nachname := fperson.Nachname;
            Persontab[h2].Firmenname := fperson.Firmenname;
            Persontab[h2].Vorname := fperson.Vorname;
            Persontab[h2].Partnertelefon := fperson.Partnertelefon;
            Persontab[h2].Partnernachname := fperson.Partnernachname;
            Persontab[h2].Partnervorname := fperson.Partnervorname;
            Persontab[h2].Partneranrede := fperson.Partneranrede;
            Persontab[h2].Satzart := True;
            Personzaehl := Personzaehl + 1;
            Updperson := True;
            Ladenpersonen;
          end;
        end
        else
        begin
          JaNein := messagedlg('Person/Firma ändern?', mtConfirmation, [mbYes, mbNo], 0);
          if (JaNein = mrYes) then
          begin
            h2 := fperson.Nummer;
            Persontab[h2].Nummer := h2;
            Persontab[h2].Art := fperson.Art;
            Persontab[h2].Land := fperson.Land;
            Persontab[h2].Email := fperson.Email;
            Persontab[h2].Handy := fperson.Handy;
            Persontab[h2].Telefon := fperson.Telefon;
            Persontab[h2].Ort := fperson.Ort;
            Persontab[h2].Plz := fperson.Plz;
            Persontab[h2].Hausnummer := fperson.Hausnummer;
            Persontab[h2].Strasse := fperson.Strasse;
            Persontab[h2].Nachname := fperson.Nachname;
            Persontab[h2].Firmenname := fperson.Firmenname;
            Persontab[h2].Vorname := fperson.Vorname;
            Persontab[h2].Partnertelefon := fperson.Partnertelefon;
            Persontab[h2].Partnernachname := fperson.Partnernachname;
            Persontab[h2].Partnervorname := fperson.Partnervorname;
            Persontab[h2].Partneranrede := fperson.Partneranrede;
            Persontab[h2].Satzart := True;
            Updperson := True;
            Ladenpersonen;
          end;
        end;
        flauf := 0;
        fart := 0;
        ftasts := True;
        FBLoe;
      end
      else
      begin
        Label2.Caption := 'Partnernachname muss eingegeben werden';
        SetControlStatus(Edit14, True);
        SetVariables('', 0, 2, 0, 0, 3, 0, 5, 25, 1, 1);
        if fart = 2 then
        begin
          Edit14.Text := fperson.Partnernachname;
          ialpha := fperson.Partnernachname;
          iart := 1;
        end;
      end;
    end;
  end;
end;

procedure TFrame2.Edit1KeyPress(Sender: TObject; var Key: Char);
begin
  if flauf = 3 then
  begin
    itaste := Key;
    FeldEingabe(Edit1);
    Key := itaste;
  end;
end;

procedure TFrame2.Edit1KeyUp(Sender: TObject; var Key: Word; Shift: TShiftState);
var
  h1: String;
begin
  Shift := Shift;
  if flauf = 3 then
  begin
    if ((istell = ilanmax) and (Ord(itaste) > 0) and (iautocr = 1)) then
    begin
      Key := Ord(chr(13));
    end;
    if Ord(Key) = 13 then
    begin
      Label2.Caption := '';
      istell := 0;
      SetControlStatus(Edit1, False, '@');
      h1 := Edit1.Text;
      ialpha := Blankweg(3, h1);
      if ialpha <> '' then
      begin
        fperson.Vorname := ialpha;
        flauf := 4;
        SetControlStatus(Edit2, True);
        SetVariables('', 0, 2, 0, 0, 3, 0, 5, 25, 1, 1);
        if fart = 2 then
        begin
          Edit2.Text := fperson.Nachname;
          ialpha := fperson.Nachname;
          iart := 1;
        end;
      end
      else
      begin
        Label2.Caption := 'Vorname muss eingegeben werden';
        SetControlStatus(Edit1, True);
        SetVariables('', 0, 2, 0, 0, 3, 0, 5, 25, 1, 1);
        if fart = 2 then
        begin
          Edit1.Text := fperson.Vorname;
          ialpha := fperson.Vorname;
          iart := 1;
        end;
      end;
    end;
  end;
end;

procedure TFrame2.Edit2KeyPress(Sender: TObject; var Key: Char);
begin
  if flauf = 4 then
  begin
    itaste := Key;
    FeldEingabe(Edit2);
    Key := itaste;
  end;
end;

procedure TFrame2.Edit2KeyUp(Sender: TObject; var Key: Word; Shift: TShiftState);
var
  h1: String;
begin
  Shift := Shift;
  if flauf = 4 then
  begin
    if ((istell = ilanmax) and (Ord(itaste) > 0) and (iautocr = 1)) then
    begin
      Key := Ord(chr(13));
    end;
    if Ord(Key) = 13 then
    begin
      Label2.Caption := '';
      istell := 0;
      SetControlStatus(Edit2, False, '@');
      h1 := Edit2.Text;
      ialpha := Blankweg(3, h1);
      if ialpha <> '' then
      begin
        fperson.Nachname := ialpha;
        flauf := 5;
        SetControlStatus(Edit3, True);
        SetVariables('', 0, 2, 0, 0, 3, 0, 5, 30, 1, 1);
        if fart = 2 then
        begin
          Edit3.Text := fperson.Strasse;
          ialpha := fperson.Strasse;
          iart := 1;
        end;
      end
      else
      begin
        Label2.Caption := 'Nachname muss eingegeben werden';
        SetControlStatus(Edit2, True);
        SetVariables('', 0, 2, 0, 0, 3, 0, 5, 25, 1, 1);
        if fart = 2 then
        begin
          Edit2.Text := fperson.Nachname;
          ialpha := fperson.Nachname;
          iart := 1;
        end;
      end;
    end;
  end;
end;

procedure TFrame2.Edit3KeyPress(Sender: TObject; var Key: Char);
begin
  if flauf = 5 then
  begin
    itaste := Key;
    FeldEingabe(Edit3);
    Key := itaste;
  end;
end;

procedure TFrame2.Edit3KeyUp(Sender: TObject; var Key: Word; Shift: TShiftState);
var
  h1: String;
begin
  Shift := Shift;
  if flauf = 5 then
  begin
    if ((istell = ilanmax) and (Ord(itaste) > 0) and (iautocr = 1)) then
    begin
      Key := Ord(chr(13));
    end;
    if Ord(Key) = 13 then
    begin
      Label2.Caption := '';
      istell := 0;
      SetControlStatus(Edit3, False, '@');
      h1 := Edit3.Text;
      ialpha := Blankweg(3, h1);
      if ialpha <> '' then
      begin
        fperson.Strasse := ialpha;
        flauf := 6;
        SetControlStatus(Edit4, True);
        SetVariables('', 0, 2, 0, 0, 3, 0, 5, 5, 1, 1);
        if fart = 2 then
        begin
          Edit4.Text := fperson.Hausnummer;
          ialpha := fperson.Hausnummer;
          iart := 1;
        end;
      end
      else
      begin
        Label2.Caption := 'Strasse muss eingegeben werden';
        SetControlStatus(Edit3, True);
        SetVariables('', 0, 2, 0, 0, 3, 0, 5, 30, 1, 1);
        if fart = 2 then
        begin
          Edit3.Text := fperson.Strasse;
          ialpha := fperson.Strasse;
          iart := 1;
        end;
      end;
    end;
  end;
end;

procedure TFrame2.Edit4KeyPress(Sender: TObject; var Key: Char);
begin
  if flauf = 6 then
  begin
    itaste := Key;
    FeldEingabe(Edit4);
    Key := itaste;
  end;
end;

procedure TFrame2.Edit4KeyUp(Sender: TObject; var Key: Word; Shift: TShiftState);
var
  h1: String;
begin
  Shift := Shift;
  if flauf = 6 then
  begin
    if ((istell = ilanmax) and (Ord(itaste) > 0) and (iautocr = 1)) then
    begin
      Key := Ord(chr(13));
    end;
    if Ord(Key) = 13 then
    begin
      Label2.Caption := '';
      istell := 0;
      SetControlStatus(Edit4, False, '@');
      h1 := ialpha;
      ialpha := Blankweg(3, h1);
      if ialpha <> '' then
      begin
        fperson.Hausnummer := ialpha;
        flauf := 7;
        SetControlStatus(Edit5, True);
        SetVariables('', 0, 2, 0, 0, 3, 0, 5, 10, 1, 1);
        if fart = 2 then
        begin
          Edit5.Text := fperson.Plz;
          ialpha := fperson.Plz;
          iart := 1;
        end;
      end
      else
      begin
        Label2.Caption := 'Hausnummer muss eingegeben werden';
        SetControlStatus(Edit4, True);
        SetVariables('', 0, 2, 0, 0, 3, 0, 5, 5, 1, 1);
        if fart = 2 then
        begin
          Edit4.Text := fperson.Hausnummer;
          ialpha := fperson.Hausnummer;
          iart := 1;
        end;
      end;
    end;
  end;
end;

procedure TFrame2.Edit5KeyPress(Sender: TObject; var Key: Char);
begin
  if flauf = 7 then
  begin
    itaste := Key;
    FeldEingabe(Edit5);
    Key := itaste;
  end;
end;

procedure TFrame2.Edit5KeyUp(Sender: TObject; var Key: Word; Shift: TShiftState);
var
  h1: String;
begin
  Shift := Shift;
  if flauf = 7 then
  begin
    if ((istell = ilanmax) and (Ord(itaste) > 0) and (iautocr = 1)) then
    begin
      Key := Ord(chr(13));
    end;
    if Ord(Key) = 13 then
    begin
      Label2.Caption := '';
      istell := 0;
      SetControlStatus(Edit5, False, '@');
      h1 := ialpha;
      ialpha := Blankweg(3, h1);
      if ialpha <> '' then
      begin
        fperson.Plz := ialpha;
        flauf := 8;
        SetControlStatus(Edit6, True);
        SetVariables('', 0, 2, 0, 0, 3, 0, 5, 30, 1, 1);
        if fart = 2 then
        begin
          Edit6.Text := fperson.Ort;
          ialpha := fperson.Ort;
          iart := 1;
        end;
      end
      else
      begin
        Label2.Caption := 'Postleitzahl muss eingegeben werden';
        SetControlStatus(Edit5, True);
        SetVariables('', 0, 2, 0, 0, 3, 0, 5, 10, 1, 1);
        if fart = 2 then
        begin
          Edit5.Text := fperson.Plz;
          ialpha := fperson.Plz;
          iart := 1;
        end;
      end;
    end;
  end;
end;

procedure TFrame2.Edit6KeyPress(Sender: TObject; var Key: Char);
begin
  if flauf = 8 then
  begin
    itaste := Key;
    FeldEingabe(Edit6);
    Key := itaste;
  end;
end;

procedure TFrame2.Edit6KeyUp(Sender: TObject; var Key: Word; Shift: TShiftState);
var
  h1: String;
begin
  Shift := Shift;
  if flauf = 8 then
  begin
    if ((istell = ilanmax) and (Ord(itaste) > 0) and (iautocr = 1)) then
    begin
      Key := Ord(chr(13));
    end;
    if Ord(Key) = 13 then
    begin
      Label2.Caption := '';
      istell := 0;
      SetControlStatus(Edit6, False, '@');
      h1 := Edit6.Text;
      ialpha := Blankweg(3, h1);
      if ialpha <> '' then
      begin
        fperson.Ort := ialpha;
        flauf := 9;
        SetControlStatus(Edit7, True);
        SetVariables('', 0, 2, 0, 0, 3, 0, 5, 20, 1, 1);
        if fart = 2 then
        begin
          Edit7.Text := fperson.Telefon;
          ialpha := fperson.Telefon;
          iart := 1;
        end;
      end
      else
      begin
        Label2.Caption := 'Ort muss eingegeben werden';
        SetControlStatus(Edit6, True);
        SetVariables('', 0, 2, 0, 0, 3, 0, 5, 30, 1, 1);
        if fart = 2 then
        begin
          Edit6.Text := fperson.Ort;
          ialpha := fperson.Ort;
          iart := 1;
        end;
      end;
    end;
  end;
end;

procedure TFrame2.Edit7KeyPress(Sender: TObject; var Key: Char);
begin
  if flauf = 9 then
  begin
    itaste := Key;
    FeldEingabe(Edit7);
    Key := itaste;
  end;
end;

procedure TFrame2.Edit7KeyUp(Sender: TObject; var Key: Word; Shift: TShiftState);
var
  h1: String;
begin
  Shift := Shift;
  if flauf = 9 then
  begin
    if ((istell = ilanmax) and (Ord(itaste) > 0) and (iautocr = 1)) then
    begin
      Key := Ord(chr(13));
    end;
    if Ord(Key) = 13 then
    begin
      Label2.Caption := '';
      istell := 0;
      SetControlStatus(Edit7, False, '@');
      h1 := ialpha;
      ialpha := Blankweg(3, h1);
      fperson.Telefon := ialpha;
      flauf := 10;
      SetControlStatus(Edit8, True);
      SetVariables('', 0, 2, 0, 0, 3, 0, 5, 20, 1, 1);
      if fart = 2 then
      begin
        Edit8.Text := fperson.Handy;
        ialpha := fperson.Handy;
        iart := 1;
      end;
    end;
  end;
end;

procedure TFrame2.Edit8KeyPress(Sender: TObject; var Key: Char);
begin
  if flauf = 10 then
  begin
    itaste := Key;
    FeldEingabe(Edit8);
    Key := itaste;
  end;
end;

procedure TFrame2.Edit8KeyUp(Sender: TObject; var Key: Word; Shift: TShiftState);
var
  h1: String;
begin
  Shift := Shift;
  if flauf = 10 then
  begin
    if ((istell = ilanmax) and (Ord(itaste) > 0) and (iautocr = 1)) then
    begin
      Key := Ord(chr(13));
    end;
    if Ord(Key) = 13 then
    begin
      Label2.Caption := '';
      istell := 0;
      SetControlStatus(Edit8, False, '@');
      h1 := ialpha;
      ialpha := Blankweg(3, h1);
      fperson.Handy := ialpha;
      if ((fperson.Telefon = '') and (fperson.Handy = '')) then
      begin
        Label2.Caption := 'Telefon und/oder Handy muss eingegeben werden';
        flauf := 9;
        SetControlStatus(Edit7, True);
        SetVariables('', 0, 2, 0, 0, 3, 0, 5, 20, 1, 1);
        if fart = 2 then
        begin
          Edit7.Text := fperson.Telefon;
          ialpha := fperson.Telefon;
          iart := 1;
        end;
      end
      else
      begin
        flauf := 11;
        SetControlStatus(Edit10, True);
        SetVariables('', 0, 2, 0, 0, 3, 0, 5, 30, 1, 1);
        if fart = 2 then
        begin
          Edit10.Text := fperson.Email;
          ialpha := fperson.Email;
          iart := 1;
        end;
      end;
    end;
  end;
end;

procedure TFrame2.Edit9KeyPress(Sender: TObject; var Key: Char);
begin
  if flauf = 2 then
  begin
    itaste := Key;
    FeldEingabe(Edit9);
    Key := itaste;
  end;
end;

procedure TFrame2.Edit9KeyUp(Sender: TObject; var Key: Word; Shift: TShiftState);
var
  h1: String;
begin
  Shift := Shift;
  if flauf = 2 then
  begin
    if ((istell = ilanmax) and (Ord(itaste) > 0) and (iautocr = 1)) then
    begin
      Key := Ord(chr(13));
    end;
    if Ord(Key) = 13 then
    begin
      Label2.Caption := '';
      istell := 0;
      SetControlStatus(Edit9, False, '@');   //text='@' - don't change!!!
      h1 := Edit9.Text;
      ialpha := Blankweg(3, h1);
      if ialpha <> '' then
      begin
        fperson.Firmenname := ialpha;
        flauf := 3;
        SetControlStatus(Edit1, True);
        SetVariables('', 0, 2, 0, 0, 3, 0, 5, 25, 1, 1);
        if fart = 2 then
        begin
          Edit1.Text := fperson.Vorname;
          ialpha := fperson.Vorname;
          iart := 1;
        end;
      end
      else
      begin
        Label2.Caption := 'Firmenname muss eingegeben werden';
        SetControlStatus(Edit9, True);
        SetVariables('', 0, 2, 0, 0, 3, 0, 5, 30, 1, 1);
        if fart = 2 then
        begin
          Edit9.Text := fperson.Firmenname;
          ialpha := fperson.Firmenname;
          iart := 1;
        end;
      end;
    end;
  end;
end;

procedure TFrame2.Button1Click(Sender: TObject);
var
  h1: Integer;
  h2: Integer;
begin
  Label1.Caption := UTF8Encode(#169) + 'LINSOFT               Projektverwaltung                   Datum: ' + FormatDateTime('DD.MM.YYYY', now);
  if ftasts then
  begin
    Label2.Caption := '';
    h2 := 0;
    for h1 := 1 to Personmax do
    begin
      if h2 = 0 then
      begin
        if not Persontab[h1].Satzart then
        begin
          h2 := h1;
        end;
      end;
    end;
    if h2 > 0 then
    begin
      fperson.Nummer := h2;
      fperson.Firmenname := '';
      fperson.Partneranrede := '';
      fperson.Partnervorname := '';
      fperson.Partnernachname := '';
      fperson.Partnertelefon := '';
      fperson.Satzart := True;
      Label22.Caption := IntToStr(h2);
      ftasts := False;
      fart := 1;
      flauf := 1;
      SetControlStatus(ComboBox1, True);
    end
    else
    begin
      Label2.Caption := 'kein anlegen Person mehr möglich, maximale Anzahl erreicht';
    end;
  end;
end;

procedure TFrame2.Button2Click(Sender: TObject);
var
  h1: String;
  h2: Integer;
begin
  Label1.Caption := UTF8Encode(#169) + 'LINSOFT               Projektverwaltung                   Datum: ' + FormatDateTime('DD.MM.YYYY', now);
  if ftasts then
  begin
    Label2.Caption := '';
    if fgrid > 0 then
    begin
      h1 := StringGrid1.Cells[0, fgrid];
      h2 := Length(h1);
      if h2 > 0 then
      begin
        h2 := StrToInt(h1);
        if ((h2 > 0) and (h2 < 10000)) then
        begin
          ftasts := False;
          fart := 2;
          flauf := 1;
          fperson.Nummer := h2;
          fperson.Art := Persontab[h2].Art;
          fperson.Satzart := Persontab[h2].Satzart;
          fperson.Vorname := Persontab[h2].Vorname;
          fperson.Nachname := Persontab[h2].Nachname;
          fperson.Strasse := Persontab[h2].Strasse;
          fperson.Hausnummer := Persontab[h2].Hausnummer;
          fperson.Plz := Persontab[h2].Plz;
          fperson.Ort := Persontab[h2].Ort;
          fperson.Telefon := Persontab[h2].Telefon;
          fperson.Handy := Persontab[h2].Handy;
          fperson.Email := Persontab[h2].Email;
          fperson.Land := Persontab[h2].Land;
          fperson.Firmenname := Persontab[h2].Firmenname;
          fperson.Partneranrede := Persontab[h2].Partneranrede;
          fperson.Partnervorname := Persontab[h2].Partnervorname;
          fperson.Partnernachname := Persontab[h2].Partnernachname;
          fperson.Partnertelefon := Persontab[h2].Partnertelefon;
          fperson.Satzart := True;
          ComboBox2.Text := fperson.Partneranrede;
          Edit1.Text := fperson.Vorname;
          Edit2.Text := fperson.Nachname;
          Edit3.Text := fperson.Strasse;
          Edit4.Text := fperson.Hausnummer;
          Edit5.Text := fperson.Plz;
          Edit6.Text := fperson.Ort;
          Edit7.Text := fperson.Telefon;
          Edit8.Text := fperson.Handy;
          Edit9.Text := fperson.Firmenname;
          Edit10.Text := fperson.Email;
          Edit11.Text := fperson.Land;
          Edit12.Text := fperson.Partnertelefon;
          Edit13.Text := fperson.Partnervorname;
          Edit14.Text := fperson.Partnernachname;
          Label22.Caption := IntToStr(h2);
          SetControlStatus(ComboBox1, True, fperson.Art);
        end
        else
        begin
          Label2.Caption := 'Perosnennummer nicht zulässig';
        end;
      end
      else
      begin
        Label2.Caption := 'Perosnennummer ist leer';
      end;
    end
    else
    begin
      Label2.Caption := 'erst Person/Firma im Stringgrid anklicken';
    end;
  end;
end;

procedure TFrame2.Button3Click(Sender: TObject);
var
  h1: String;
  h2: Integer;
  JaNein: TModalResult;
begin
  Label1.Caption := UTF8Encode(#169) + 'LINSOFT               Projektverwaltung                   Datum: ' + FormatDateTime('DD.MM.YYYY', now);
  if ftasts then
  begin
    Label2.Caption := '';
    if fgrid > 0 then
    begin
      h1 := StringGrid1.Cells[0, fgrid];
      h2 := Length(h1);
      if h2 > 0 then
      begin
        h2 := StrToInt(h1);
        if ((h2 > 0) and (h2 < 10000)) then
        begin
          ftasts := False;
          fart := 3;
          flauf := 0;
          fperson.Nummer := h2;
          fperson.Art := Persontab[h2].Art;
          fperson.Satzart := Persontab[h2].Satzart;
          fperson.Vorname := Persontab[h2].Vorname;
          fperson.Nachname := Persontab[h2].Nachname;
          fperson.Strasse := Persontab[h2].Strasse;
          fperson.Hausnummer := Persontab[h2].Hausnummer;
          fperson.Plz := Persontab[h2].Plz;
          fperson.Ort := Persontab[h2].Ort;
          fperson.Telefon := Persontab[h2].Telefon;
          fperson.Handy := Persontab[h2].Handy;
          fperson.Email := Persontab[h2].Email;
          fperson.Land := Persontab[h2].Land;
          fperson.Firmenname := Persontab[h2].Firmenname;
          fperson.Partneranrede := Persontab[h2].Partneranrede;
          fperson.Partnervorname := Persontab[h2].Partnervorname;
          fperson.Partnernachname := Persontab[h2].Partnernachname;
          fperson.Partnertelefon := Persontab[h2].Partnertelefon;
          fperson.Satzart := True;
          ComboBox1.Text := fperson.Art;
          ComboBox2.Text := fperson.Partneranrede;
          Edit1.Text := fperson.Vorname;
          Edit2.Text := fperson.Nachname;
          Edit3.Text := fperson.Strasse;
          Edit4.Text := fperson.Hausnummer;
          Edit5.Text := fperson.Plz;
          Edit6.Text := fperson.Ort;
          Edit7.Text := fperson.Telefon;
          Edit8.Text := fperson.Handy;
          Edit9.Text := fperson.Firmenname;
          Edit10.Text := fperson.Email;
          Edit11.Text := fperson.Land;
          Edit12.Text := fperson.Partnertelefon;
          Edit13.Text := fperson.Partnervorname;
          Edit14.Text := fperson.Partnernachname;
          Label22.Caption := IntToStr(h2);
          JaNein := messagedlg('Person/Firma löschen?', mtConfirmation, [mbYes, mbNo], 0);
          if (JaNein = mrYes) then
          begin
            h2 := fperson.Nummer;
            Persontab[h2].Satzart := False;
            Personzaehl := Personzaehl - 1;
            Updperson := True;
            Ladenpersonen;
          end;
          flauf := 0;
          fart := 0;
          ftasts := True;
          FBLoe;
        end
        else
        begin
          Label2.Caption := 'Perosnennummer nicht zulässig';
        end;
      end
      else
      begin
        Label2.Caption := 'Perosnennummer ist leer';
      end;
    end
    else
    begin
      Label2.Caption := 'erst Person/Firma im Stringgrid anklicken';
    end;
  end;
end;

procedure TFrame2.StringGrid1SelectCell(Sender: TObject; aCol, aRow: Integer; var CanSelect: Boolean);
begin
  aCol := aCol;
  fgrid := aRow;
  CanSelect := True;
end;

procedure TFrame2.Timer1Timer(Sender: TObject);
begin
  Timer1.Enabled := False;
  Ladenpersonen;
end;

procedure TFrame2.SetVariables(aialpha: String; ainummer, aiart, ainumkom, aikomma, aizeich, aistell, aifunc, ailanmax, ailanmin, aiautocr: Integer);
begin
  ialpha := aialpha;
  inummer := ainummer;
  iart := aiart;
  inumkom := ainumkom;
  ikomma := aikomma;
  izeich := aizeich;
  istell := aistell;
  ifunc := 5;
  ilanmax := ailanmax;
  ilanmin := ailanmin;
  iautocr := aiautocr;
end;

procedure TFrame2.SetControlStatus(ctrl: TObject; aenabled: Boolean; atext: String); //if text=@ then don't change
var
  idx: Integer;
  acolor: TColor;
begin
  if not ((ctrl is TEdit) or (ctrl is TComboBox)) then
    exit;
  if aenabled then
    acolor := $0080FFFF
  else
    acolor := $00C0C0C0;
  if ctrl is TEdit then
  begin
    TEdit(ctrl).Enabled := aenabled;
    TEdit(ctrl).ReadOnly := not aenabled;
    TEdit(ctrl).TabStop := aenabled;
    TEdit(ctrl).Color := acolor;
    if atext <> '@' then
      TEdit(ctrl).Text := atext;
    if aenabled then
      TEdit(ctrl).SetFocus;
  end
  else if ctrl is TComboBox then
  begin
    TComboBox(ctrl).Enabled := aenabled;
    TComboBox(ctrl).ReadOnly := not aenabled;
    TComboBox(ctrl).TabStop := aenabled;
    TComboBox(ctrl).Color := acolor;
    idx := -1;
    if (atext <> '') and (atext <> '@') then
      idx := TComboBox(ctrl).Items.IndexOf(atext);
    if atext <> '@' then
      TComboBox(ctrl).ItemIndex := idx;
    if aenabled then
      TComboBox(ctrl).SetFocus;
  end;
end;

constructor TFrame2.Create(AOwner1: TComponent);
var
  j: Integer;
begin
  inherited Create(AOwner);
  AOwner1 := AOwner1;
  ftasts := True;
  fart := 0;
  flauf := 0;
  fgrid := 0;
  SetControlStatus(ComboBox1, False);
  self.ComboBox1.Items.Clear;
  self.ComboBox1.Items.Add('Person');
  self.ComboBox1.Items.Add('Firma');
  SetControlStatus(ComboBox2, False);
  self.ComboBox2.Items.Clear;
  self.ComboBox2.Items.Add('ohne');
  self.ComboBox2.Items.Add('Herr');
  self.ComboBox2.Items.Add('Frau');
  SetControlStatus(Edit1, False);
  SetControlStatus(Edit2, False);
  SetControlStatus(Edit3, False);
  SetControlStatus(Edit4, False);
  SetControlStatus(Edit5, False);
  SetControlStatus(Edit6, False);
  SetControlStatus(Edit7, False);
  SetControlStatus(Edit8, False);
  SetControlStatus(Edit9, False);
  SetControlStatus(Edit10, False);
  SetControlStatus(Edit11, False);
  SetControlStatus(Edit12, False);
  SetControlStatus(Edit13, False);
  SetControlStatus(Edit14, False);
  self.Label1.Caption := UTF8Encode(#169) + 'LINSOFT               Projektverwaltung                   Datum: ' + FormatDateTime('DD.MM.YYYY', now);
  self.Label2.Caption := '';
  self.StringGrid1.RowCount := 2;
  self.StringGrid1.ColCount := 17;
  self.StringGrid1.ColWidths[0] := 120;
  self.StringGrid1.ColWidths[1] := 110;
  self.StringGrid1.ColWidths[2] := 500;
  self.StringGrid1.ColWidths[3] := 430;
  self.StringGrid1.ColWidths[4] := 430;
  self.StringGrid1.ColWidths[5] := 500;
  self.StringGrid1.ColWidths[6] := 170;
  self.StringGrid1.ColWidths[7] := 180;
  self.StringGrid1.ColWidths[8] := 500;
  self.StringGrid1.ColWidths[9] := 350;
  self.StringGrid1.ColWidths[10] := 350;
  self.StringGrid1.ColWidths[11] := 500;
  self.StringGrid1.ColWidths[12] := 500;
  self.StringGrid1.ColWidths[13] := 130;
  self.StringGrid1.ColWidths[14] := 350;
  self.StringGrid1.ColWidths[15] := 430;
  self.StringGrid1.ColWidths[16] := 430;
  self.StringGrid1.Cells[0, 0] := 'Nummer';
  self.StringGrid1.Cells[1, 0] := 'Art';
  self.StringGrid1.Cells[2, 0] := 'Firmenname';
  self.StringGrid1.Cells[3, 0] := 'Vorname';
  self.StringGrid1.Cells[4, 0] := 'Nachname';
  self.StringGrid1.Cells[5, 0] := 'Strasse';
  self.StringGrid1.Cells[6, 0] := 'Hausnummer';
  self.StringGrid1.Cells[7, 0] := 'PLZ';
  self.StringGrid1.Cells[8, 0] := 'Ort';
  self.StringGrid1.Cells[9, 0] := 'Telefon';
  self.StringGrid1.Cells[10, 0] := 'Handy';
  self.StringGrid1.Cells[11, 0] := 'EMail';
  self.StringGrid1.Cells[12, 0] := 'Land';
  self.StringGrid1.Cells[13, 0] := 'PAnrede';
  self.StringGrid1.Cells[14, 0] := 'PTelefon';
  self.StringGrid1.Cells[15, 0] := 'Partnervorname';
  self.StringGrid1.Cells[16, 0] := 'Partnernachname';
  for j := 0 to StringGrid1.ColCount - 1 do
    StringGrid1.Cells[j, 1] := '';
  self.Button2.Visible := False;
  self.Button3.Visible := False;
  if Personzaehl > 0 then
  begin
    self.Button2.Visible := True;
    self.Button3.Visible := True;
  end;
end;

procedure TFrame2.FBLoe;
begin
  SetControlStatus(ComboBox1, False);
  SetControlStatus(ComboBox2, False);
  SetControlStatus(Edit1, False);
  SetControlStatus(Edit2, False);
  SetControlStatus(Edit3, False);
  SetControlStatus(Edit4, False);
  SetControlStatus(Edit5, False);
  SetControlStatus(Edit6, False);
  SetControlStatus(Edit7, False);
  SetControlStatus(Edit8, False);
  SetControlStatus(Edit9, False);
  SetControlStatus(Edit10, False);
  SetControlStatus(Edit11, False);
  SetControlStatus(Edit12, False);
  SetControlStatus(Edit13, False);
  SetControlStatus(Edit14, False);
end;

procedure TFrame2.Ladenpersonen;
var
  z, j: Integer;
  h1: Integer;
  h2: String;
begin
  z := 1;
  Screen.Cursor := crHourGlass;
//  Form1.Frame2.Cursor := crHourGlass;  // Erledigt Scrren
  Refresh;
  for h1 := 1 to Personmax do
  begin
    if Persontab[h1].Satzart then
    begin
      z := z + 1;
      StringGrid1.RowCount := z;
      z := z - 1;
      StringGrid1.Cells[0, z] := IntToStr(Persontab[h1].Nummer);
      StringGrid1.Cells[1, z] := Persontab[h1].Art;
      StringGrid1.Cells[2, z] := Persontab[h1].Firmenname;
      StringGrid1.Cells[3, z] := Persontab[h1].Vorname;
      StringGrid1.Cells[4, z] := Persontab[h1].Nachname;
      StringGrid1.Cells[5, z] := Persontab[h1].Strasse;
      StringGrid1.Cells[6, z] := Persontab[h1].Hausnummer;
      StringGrid1.Cells[7, z] := Persontab[h1].Plz;
      StringGrid1.Cells[8, z] := Persontab[h1].Ort;
      StringGrid1.Cells[9, z] := Persontab[h1].Telefon;
      StringGrid1.Cells[10, z] := Persontab[h1].Handy;
      StringGrid1.Cells[11, z] := Persontab[h1].Email;
      StringGrid1.Cells[12, z] := Persontab[h1].Land;
      h2 := Persontab[h1].Partneranrede;
      if h2 = 'ohne' then h2 := '';
      StringGrid1.Cells[13, z] := h2;
      StringGrid1.Cells[14, z] := Persontab[h1].Partnertelefon;
      StringGrid1.Cells[15, z] := Persontab[h1].Partnervorname;
      StringGrid1.Cells[16, z] := Persontab[h1].Partnernachname;
      z := z + 1;
    end;
    Label20.Caption := IntToStr(Personzaehl);
  end;
  Screen.Cursor := crDefault;
  Refresh;
  if z = 1 then
  begin
    StringGrid1.RowCount := 2;
    for j := 0 to StringGrid1.ColCount - 1 do
      StringGrid1.Cells[j, 1] := '';
  end;
  fgrid := 0;
end;

end.
