unit uprjhelper;

{$mode ObjFPC}{$H+}

interface

uses
  Classes, SysUtils;

{ prüfen ob Ntextstring numerisch ist
  wenn nicht wird Result leer zurück gegeben
  Komma=True wenn Komma erlaubt ist
  Bei Komma wird aus '.' ein ',' gemacht}
function Nummer(Komma: Boolean; var Ntextstring: string): string;

{ Blanks in Btextstring entfernen und in Result zurück geben
  Art 1 = vor dem Text
  Art 2 = hinter dem Text
  Art 3 = vor und hinter dem Text}
function Blankweg(Art: integer; Btextstring: string): string;

{ Blanks im Htextstring einfügen und in Result zurück geben
  Lan = Ausgabelänge von Result
  Pos 1 = vor dem Text
  Pos 2 = hinter dem Text }
function Blankdazu(Pos, Lan: integer; var Htextstring: string): string;


implementation

function Nummer(Komma: Boolean; var Ntextstring: string): string;
var
 laenge: integer;
 stelle: integer;
 m: integer;
 zeichen: string;
 h1: string;
 h2: string;
 tt: string;
begin
  laenge:=Length(Ntextstring);
  tt:='';
  if laenge > 0 then
  begin
    Ntextstring:=Blankweg(3, Ntextstring);
    laenge:=Length(Ntextstring);
    if laenge > 0 then
    begin
      tt:= '';
      for stelle:=1 to laenge do
      begin
        zeichen:=Copy(Ntextstring,stelle,1);
        m:=0;
        if zeichen = '0' then
        begin
          m:=1;
        end;
        if zeichen = '1' then
        begin
          m:=1;
        end;
        if zeichen = '2' then
        begin
          m:=1;
        end;
        if zeichen = '3' then
        begin
          m:=1;
        end;
        if zeichen = '4' then
        begin
          m:=1;
        end;
        if zeichen = '5' then
        begin
          m:=1;
        end;
        if zeichen = '6' then
        begin
          m:=1;
        end;
        if zeichen = '7' then
        begin
          m:=1;
        end;
        if zeichen = '8' then
        begin
          m:=1;
        end;
        if zeichen = '9' then
        begin
          m:=1;
        end;
        if ((komma) and (zeichen = '.')) then
        begin
          m:=1;
          h1:='';
          h2:='';
          if stelle > 1 then h1:=Copy(Ntextstring,1,stelle-1);
          if ((stelle > 1) and (stelle < laenge)) then h2:=Copy(Ntextstring,stelle+1,laenge-stelle);
          tt:=h1+','+h2;
        end;
        if ((komma) and (zeichen = ',')) then
        begin
          m:=1;
        end;
        if m = 0 then
        begin
          tt:='';
        end;
      end;
    end;
  end;
  Result:=tt;
end;


function Blankweg(Art: integer; Btextstring: string): string;
//var
//  laenge: integer;
//  stelle: integer;
//  vari12: integer;
//  zeichen: string;
//  ausgabe: string;
begin
  // die Frage ist hier ob man nicht eher trim aus der sysutil verwendet
  case Art of
    1: Result:= TrimLeft(Btextstring);
    2: Result:= TrimRight(Btextstring);
  else
    Result:= trim(Btextstring);
  end;
  //laenge:=Length(Btextstring);
  //ausgabe:='';
  //if laenge > 0 then
  //begin
  //  ausgabe:=Btextstring;
  //  if ((Art = 1) or (Art = 3)) then
  //  begin
  //    vari12:=0;
  //    for stelle:=1 to laenge do
  //    begin
  //      zeichen:=Copy(Btextstring,stelle,1);
  //      if (vari12 = 0) then
  //      begin
  //        if (zeichen <> ' ') then
  //        begin
  //          vari12:=stelle;
  //        end;
  //      end;
  //    end;
  //    if vari12 > 0 then
  //    begin
  //      zeichen:=Btextstring;
  //      ausgabe:=Copy(zeichen,vari12,laenge-(vari12-1));
  //    end else begin
  //      ausgabe:='';
  //    end;
  //  end;
  //  laenge:=Length(ausgabe);
  //  if laenge > 0 then
  //  begin
  //    if ((Art = 2) or (Art = 3)) then
  //    begin
  //      vari12:=0;
  //      for stelle:=laenge downto 1 do
  //      begin
  //        zeichen:=Copy(ausgabe,stelle,1);
  //        if (vari12 = 0) then
  //        begin
  //          if (zeichen <> ' ') then
  //          begin
  //            vari12:=stelle;
  //          end;
  //        end;
  //      end;
  //      if (vari12 > 0) then
  //      begin
  //        zeichen:=ausgabe;
  //        ausgabe:=Copy(zeichen,1,vari12);
  //      end else begin
  //        ausgabe:='';
  //      end;
  //    end;
  //  end else begin
  //    ausgabe:='';
  //  end;
  //end;
  //Result:=ausgabe;
end;

function Blankdazu(Pos, Lan: integer; var Htextstring: string): string;
  var laenge: integer;
  var stelle: integer;
  var ausgabe: string;
begin
  laenge:=Length(Htextstring);
  ausgabe:=Htextstring;
  if laenge < Lan then
  begin
    while laenge < Lan do
    begin
      if Pos = 1 then
      begin
        ausgabe:=' '+ausgabe;
      end else begin
        ausgabe:=ausgabe+' ';
      end;
      laenge:=Length(ausgabe);
    end;
  end else begin
    if laenge > Lan then
    begin
      if Pos = 1 then
      begin
        stelle:=laenge-Lan+1;
        ausgabe:=Copy(Htextstring,stelle,Lan);
      end else begin
        ausgabe:=Copy(Htextstring,1,Lan);
      end;
    end;
  end;
  Result:=ausgabe;
end;


end.

