unit uvorgang;

{$mode ObjFPC}{$H+}

interface

uses
  Classes, SysUtils;

const
  Vorgangmax: integer = 9999;

type
  Tvorgang = record                                                          // Satzaufbau Vorgänge
    Projektnummer: integer;
    Vorgangnummer: integer;
    Kurzbeschreibung: string;
    Langbeschreibung: array of string;
    Anzahl: integer;
    Status: string;                                                               // erfasst/gestartet/beendet
    Sollstarttermin: TDateTime;
    Sollendtermin: TDateTime;
    Iststarttermin: TDateTime;
    Istendtermin: TDateTime;
    Terminart: string;                                                            // Festtermin/Variabletermin
    Verantwortlich: integer;
    Ausfuehrend: integer;
    Vorgaenger: integer;
    Nachfolger: integer;
    Satzart: Boolean;                                                             // aktiv/passiv
    vonX: integer;
    vonY: integer;
    bisX: integer;
    bisY: integer;
  end;

 TVorgaenge =  array of TVorgang;

var
  Vorgangtab: TVorgaenge;                                                       // Tabelle Vorgänge
  Vorgangzaehl: integer;                                                        // Zähler Tabelle Vorgänge
  Updvorgang: Boolean;                                                          // Vorgangstabelle wurde geändert

implementation

end.

